/*
    File:       board128.cpp
    Version:    0.1.0
    Date:       Feb. 21, 2013
	License:	GPL v2
    
	atmega128 board code
    
    ****************************************************************************
    Copyright (C) 2013 Radu Motisan  <radu.motisan@gmail.com>

	http://www.pocketmagic.net

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ****************************************************************************
 */

#include <avr/io.h>
#include "timeout.h"
#include <util/delay.h>
#include "led.h"
#include "pir.h"
//#include "lcd/hd44780.h"
#include "lcd/3w_hd44780_8bit.h"
// atmega128 has two leds connected to PA0 and PA1
LED led1, led2;

PIR pir1;

//HD44780 lcd;
HD44780_3W_8BIT lcd;

int main(void)
{
	// init leds
	led1.Init(&DDRA, &PORTA, 0); //DDRA, PORTA, PA0
	led2.Init(&DDRA, &PORTA, 1); //DDRA, PORTA, PA1
	led1.Set(0);led2.Set(1);
	
	// init pir sensor
	//pir1.Init(&DDRC, &PINC, 0);pir1.Get();
	lcd.Init(&PORTC,PC0,	// data/rs
			 &PORTC, PC1,	// clk
			 &PORTC, PC2);  // lcd e
	// init LCD: RS, E, D4, D5, D6, D7
	//lcd.lcd_init(&PORTA,PA6, &PORTA,PA7,
	//	&PORTA, PA5, &PORTA, PA4, &PORTA, PA3,&PORTA, PA2);


	int i = 0;
    while(1)
    {
		i++;
		lcd.lcd_cursor_home();
		lcd.lcd_string_format("www.pocketmagic.net   \n3 Wires LCD HD44780\nwith 74HC164+mega128\nline 4:%d",i);
			  
		led1.Toggle();
		led2.Toggle();
        _delay_ms(500);
    }
}